if exists("did_load_filetypes")
  finish
endif

augroup filetypedetect
  au BufRead,BufNewFile *.sb               setf scheme
  au BufRead,BufNewFile *.JS               setf javascript
  au BufRead,BufNewFile *.jas              setf asm
  au BufRead,BufNewFile *.swfml            setf xml
  au BufRead,BufNewFile *.hx               setf haxe

  au BufRead,BufNewFile *.tpl              setf xhtml
  au BufRead,BufNewFile *.blk              setf c
  au BufRead,BufNewFile *.blkk             setf cpp
  au BufRead,BufNewFile *.adoc             setf asciidoc

  au BufRead,BufNewFile massif.*.txt       setf massif
  au BufRead,BufNewFile peer*.log          setf ubiquity-log

  " HTML (.shtml and .stm for server side)
  au BufNewFile,BufRead *.html,*.htm,*.shtml,*.stm  call s:FThtml()

  au BufNewFile,BufRead {mad,}mutt{ng,}-*-\w\+ setf mail

  au BufNewFile,BufRead */X11/xkb/* setf xkb

  au BufNewFile,BufRead *.as setf actionscript

  au BufNewFile,BufRead *.dox setf doxygen

  au BufNewFile,BufRead *.iop setf d

  au BufNewFile,BufRead .gitsendemail.* setf gitsendemail
  au BufNewFile,BufRead COMMIT_EDITMSG  setf gitcommit
  au BufNewFile,BufRead *.git/modules/*/config  setf gitconfig

  " Distinguish between HTML, XHTML and Django
  fun! s:FThtml()
    let n = 1
    while n < 10 && n < line("$")
      if getline(n) =~ '<?'
        setf php
        return
      endif
      if getline(n) =~ '\<DTD\s\+XHTML\s'
        setf xhtml
        return
      endif
      if getline(n) =~ '{%\s*\(extends\|block\)\>'
        setf htmldjango
        return
      endif
      let n = n + 1
    endwhile
    setf html
  endfun

augroup END
